/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef QCATAGORYLIST_20061222_H_
#define QCATAGORYLIST_20061222_H_

#include <QTreeWidget>
#include <QItemDelegate>

class QTreeWidgetItem;
class QString;

class QCatagoryList : public QTreeWidget {
	Q_OBJECT
	
public:
	QCatagoryList(QWidget *parent = 0);
	virtual ~QCatagoryList();
	
private slots:
    void handleMousePress(QTreeWidgetItem *item);
	
public:
	QTreeWidgetItem *addCatagory(const QString &name);
	QTreeWidgetItem *addItem(QTreeWidgetItem *catagory, const QString &value);
	bool isCatagory(QTreeWidgetItem *item) const;
};


class SheetDelegate: public QItemDelegate {

public:
    SheetDelegate(QTreeView *view, QWidget *parent);

    virtual void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;
    virtual QSize sizeHint(const QStyleOptionViewItem &opt, const QModelIndex &index) const;

private:
    QTreeView *m_view;
};

#endif

