
find_functions(address) {
	uint8_t buffer[MAX_INSN_SIZE];
	
	Instruction insn;
	State state;
	QSet<BaseTypes::address_t> set;
	
	MemoryRegions::Region region;
	
	if(Debugger::memoryRegions != 0 && Debugger::memoryRegions->findRegion(address, region)) {

		for(unsigned int i = region.start; i < region.end; ++i) {
			Debugger::debuggerBase->readBytes(i, buffer, sizeof(buffer));
			const int size = insn.disassemble(buffer, sizeof(buffer), i, 0);
			if(size != 0) {
				if(insn.type() == insn_call || insn.type() == insn_callcc) {

					state.eip = i;
					BaseTypes::address_t ret = 0;
					switch(insn.operand_1st()->type()) {
					case op_absolute:
					case op_relative_near:
					case op_relative_far:
						ret = insn.operand_1st()->effectiveAddress(state);
						break;
					default:
						break;
					}

					if(ret != 0) {
						if(ret >= region.start && ret < region.end) {
							set.insert(ret);
						}
					}
				}
			}
		}

		for(QSet<BaseTypes::address_t>::const_iterator it = set.begin(); it != set.end(); ++it) {
			printf("%08x\n", *it);
		}
	}
}
